package com.loafle.bridge.discoveryport.entity;

import com.loafle.bridge.discoveryhost.entity.DiscoveryHost;
import com.loafle.bridge.discoveryport.constant.PortType;

import javax.persistence.*;
import java.util.Date;
import java.util.List;

@Entity
public class DiscoveryPort {

    @Id
    @Column(name = "ID")
    @GeneratedValue(strategy = GenerationType.AUTO)
    private long id;

    @ManyToOne
    @JoinColumn(name = "HOST_ID", nullable = false)
    private DiscoveryHost host;

    @Column(name = "PORT_TYPE",nullable = false)
    @Enumerated(EnumType.STRING)
    private PortType type;

    @Column(name = "PORT_NUMBER",nullable = false)
    private short portNumber;

    @OneToMany(mappedBy = "port" , fetch = FetchType.LAZY)
    private List<ServiceScanHistory> histories;

    @Column(name = "CREATE_AT",nullable = false,updatable = false)
    @Temporal(TemporalType.TIMESTAMP)
    private Date createAt;

    @Column(name = "UPDATE_AT",nullable = false)
    @Temporal(TemporalType.TIMESTAMP)
    private Date updateAt;


    public DiscoveryPort() {}

    public DiscoveryHost getHost() {
        return host;
    }

    public void setHost(DiscoveryHost host) {
        this.host = host;
    }

    public DiscoveryPort(PortType type, DiscoveryHost host, short port, Date createAt, Date updateAt) {
        this.host = host;

        this.type = type;
        this.portNumber = port;
        this.createAt = createAt;
        this.updateAt = updateAt;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public PortType getType() {
        return type;
    }

    public void setType(PortType type) {
        this.type = type;
    }

    public short getPortNumber() {
        return portNumber;
    }

    public void setPortNumber(short portNumber) {
        this.portNumber = portNumber;
    }

    public Date getCreateAt() {
        return createAt;
    }

    public void setCreateAt(Date createAt) {
        this.createAt = createAt;
    }

    public Date getUpdateAt() {
        return updateAt;
    }

    public void setUpdateAt(Date updateAt) {
        this.updateAt = updateAt;
    }

    public List<ServiceScanHistory> getHistories() {
        return histories;
    }

    public void setHistories(List<ServiceScanHistory> histories) {
        this.histories = histories;
    }
}
